<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Interface Dataflow en PLT</TITLE>
<META NAME="GENERATOR" CONTENT="Arachnophilia Version 2.1">
<META NAME="FORMATTER" CONTENT="Arachnophilia Version 2.1">
</HEAD>

<BODY BACKGROUND="" BGCOLOR="#0000ff" TEXT="#ffff00" LINK="#80ff80" VLINK="#c0c0c0" ALINK="#ff0000">

<CENTER><H1>Interface Dataflow en PLT</H1>
</CENTER>

<H2>Pourquoi Scheme, pourquoi cette implantation?
</H2>

Scheme vit toujours,et se porte <FONT COLOR=#80ffff size=+1>très</FONT> bien. On peut même affirmer (c'est discutable...) que Scheme se porte mieux que Common Lisp, notamment dans le monde académique, où d'autres critères que la force brute semblent prévaloir. On voit que :
<UL>
<LI>Dans le monde Linux le logiciel de traitement d'images <I>nec plus ultra</I> est le Gimp - scripté en Scheme.
<LI>Les standards Gnome/Guile gagnent du terrain. 
<LI>On trouve de plus en plus d'applications basées sur Elk.
<LI>Une compagne spécialisée : Schemers INC. qui vend des logiciels de modélisation 3D implantés en Scheme continue à fonctionner, et probablement fait des bénéfices.
<LI>Un populaire système pédagogique d'animation (AI) est basé sur Scheme,
</UL>
... et cette liste aurait pu être 10 fois plus longue. Bien sûr, en ce qui concerne la vitesse, Scheme est perdant contre C++, car c'est un langage à typage dynamique, et où la gestion dynamique de mémoire est importante et onéreuse. Les compilateurs integrés Scheme n'ont pas été conçus pour générer un super-code. Ce problème ne nous concerne pas.
<p>

Scheme continue à évoluer, de noueaux standards sont sur la table de montage, mais il reste extrêmement stable ! La grande conférence internationale sur la programmation fonctionnelle (Baltimore, 27.09.1988), qui est dediée principalement à des langages plus récents, comme Haskell, consacre néanmoins un Workshop entier à Scheme.

<p><hr><p>

Le paquetage  PLT (MzScheme, DrScheme, MrEd, Zodiac etc.) est utilisés à Caen depuis 4 ans, en DEUG. Les concepteurs (Rice University) corrigent les bugs, et offrent le paquetage pour toutes les plates-formes populaires. Le dialecte est toujour mis à jour vis-à-vis le standard, et même anticipe les nouveautés, par exemple le retour de multiples valeurs, ce qui est très important pour nous (pour le multiplexage des chemins de données).
<p>

PLT Scheme est équipé avec un sous-système complet de développement graphique, l'interface DrScheme a été construite en Scheme même. Tout est là, et le système est bien documenté et <FONT COLOR=#ff8040>facilement</FONT> extensible. Ce n'est pas un jouet ! PLT Scheme a déjà survécu quelques implantations commerciales, et il constitue un véritable environnement de "production" pour un informaticien moderne. Notamment :
<UL>
<LI>Il sait gérér les exceptions.
<LI>Il permet de manière très propre la construction et gestion du parallélisme local (threading), et de toutes les"goodies" sémantiques caractéristiques de la programmation fonctionnelle, comme les flots paresseux, les continuations, etc.

<LI>Il est équipé avec une couche objet <FONT COLOR=#80ff00>très puissante et universelle, et commode</FONT> (malgré les reticences de quelques uns de mes collègues...)
<LI>
</UL>

<p>
Problème fondamental avec cette implantation est la lourdeur. C'est un système très gourmand. 

<p><hr><p>

<H2>Que va-t-on faire avec?
</H2>

L'étudiant doit lire attentivement les exemples graphiques fournis avec MrEd, notamment tout ce qui touche l'interfaçage, et commencer à faire un simple éditeur graphique, capable de placer sur l'écran des widgets prédéfinis, de les lier avec des chemins (bien dessinés), etc. On peut faire tout comme en Matlab ou Khoros : seulement le circuit, ou comme en LabView ou JavaStudio : avec le "panneau frontal" séparé, mais cette dernière option ne sera suggerée que si le projet est réalisé par deux personnes.
<P>

Ensuite il faudra penser à la sémantique des boîtiers. Bien sûr, il existent des cas triviaux. Si une combinaison de boîtiers genre

<CENTER><IMG SRC="img/boit2.gif" ALT="">
</CENTER>
où le flux de données va de gauche à droite, ceci doit construire une fonction qui prend un <TT>x</TT>, et qui retourne <TT>{F<SUB>2</SUB>(y),F<SUB>3</SUB>(y)} where y=F<SUB>1</SUB>(x)</TT>. Les acolades ici signifient une donnée multiple, gérée par la construction <TT>VALUES</TT> de PLT-Scheme. (Mais on en peut construire également une paire pointée ou une liste).
<P>
OK, en Scheme c'est comme ça :
<pre>
(define (bloc x)
   (let ((y (F1 x)))
        (values (F2 y) (F3 y))))
</pre>
<p>
Bien sûr, si on veut mettre F2 et F3 dans deux threads séparés, ceci est également possible. 
<P>

Il faudra prendre beaucoup de décisions concernant l'apparence extérieure, l'esthétisme du système, et ceci doit être fait en concertation avec les colègues. Il faudra gérér les boucles et autres structures de contrôle (switches, délais, etc.)
<P>

La littérature est dispersée et il faudra beaucoup discuter et s'inspirer des exemples. Une source d'information qui ne couvre pas le Dataflow, mais discute le modèle des boîtiers est le livre de Abelson et Sussman. On trouve plus d'informations pertinentes dans ces deux thèses, celle de <A HREF="pap/ReekThes.ps.gz">Reekie (PostScript)</A>, et une autre de <A HREF="pap/ChoiThes.zip">Choi (document Word)</A>, ainsi que dans quelques cours publiés sur l'Internet (les adresses et les slides sont à votre disposition). Bien sûr, je possède toute la documentation de Matlab et de LabView, et JavaStudio est raisonnablement doumenté aussi.


<p>
<FONT COLOR=#80ff00 face="Arial,Helvetica"><b>
Retour vers les <A HREF="Projets.html">Projets</A>.
</b></FONT>


</BODY>

</HTML>
